
#include "nRF24L01.h"
#include "stm8s.h"
#include "stdio.h"

uchar  TX_ADDRESS[TX_ADR_WIDTH]  = {0x34,0x43,0x10,0x10,0x01}; // Define a static TX address
uchar RX_ADDRESS[RX_ADR_WIDTH]  = {0x34,0x43,0x10,0x10,0x01}; // Define a static RX address

uchar  stat;		   //ڿλѰַ
//sbit	RX_DR	=sta^6;	  //λ
//sbit	TX_DS	=sta^5;
//sbit	MAX_RT	=sta^4;

void inerDelay_us(unsigned char n)  //Ϊʱ1US
{
for(;n>0;n--) 
  { 
      asm("nop");  //STM8棬16M_nop_() ʱ 333ns
      asm("nop");  
      asm("nop");  
      asm("nop");  
      //printf("\n\r delay \n\r");
  }
}

/*void init_io(void)
{
        inerDelay_us(100);	 //ʱ 100us
        GPIO_WriteLow(NRF24L01_CE_PORT,NRF24L01_CE_PIN);//CE Low 
 	GPIO_WriteHigh(NRF24L01_CS_PORT,NRF24L01_CS_PIN);   // Spi disable CS_HIGH()
	GPIO_WriteLow(GPIOC, GPIO_PIN_7); //SCK=0;
}*/

/**************************************************
Function: SPI_RW();

  Description:
  Writes one byte to nRF24L01, and return the byte read
  from nRF24L01 during write, according to SPI protocol
**************************************************/
uchar SPI_RW(uchar byte)
{   
/*     //while(!SPI_FLAG_TXE); 	// Wait until the transmit buffer is empty
        SPI_SendData(byte);
        while (SPI->SR & SPI_SR_TXE == 0)
            {
              /* Wait while the byte is transmitted 
            }
	while(!SPI_SR_RXNE);  //Wait to receive a byte
	byte = SPI_ReceiveData();
               //SPI_SR_RXNE
   	return(byte); */
        /*!< Wait until the transmit buffer is empty */
      uchar retry;
      while (SPI_GetFlagStatus(SPI_FLAG_TXE) == RESET)
      {}
      /*!< Send the byte */
      SPI_SendData(byte);
    
      /*!< Wait until a data is received */
      while (SPI_GetFlagStatus(SPI_FLAG_RXNE) == RESET)
      {
       // retry++;
       // if(retry>200)return 0;

      }
      /*!< Get the received data */
      byte = SPI_ReceiveData();
      return(byte);  

 /*       uchar bit_ctr;
	uchar MOSI=0;
   	for(bit_ctr=0;bit_ctr<8;bit_ctr++) // output 8-bit
   	{
		MOSI = (byte & 0x80);      //output 'byte', MSB to MOSI
		if(MOSI==0x80)
                  GPIO_WriteHigh(NRF24L01_MOSI_PORT, NRF24L01_MOSI_PIN); //MOSI : PG1 //ģд
		else   
                  GPIO_WriteLow(NRF24L01_MOSI_PORT, NRF24L01_MOSI_PIN);
	          
		byte = (byte << 1);           // shift next bit into MSB..
		GPIO_WriteHigh(NRF24L01_SCK_PORT, NRF24L01_SCK_PIN); // Set SCK high..
               
                if(GPIO_ReadInputPin(NRF24L01_MISO_PORT, NRF24L01_MISO_PIN)==1)
                    byte= ( 0x01| byte);//MISO : PG0
                if(GPIO_ReadInputPin(NRF24L01_MISO_PORT, NRF24L01_MISO_PIN)==0)
                    byte= ( 0x00| byte);//MISO : PG0
		GPIO_WriteLow(NRF24L01_SCK_PORT, NRF24L01_SCK_PIN); // ..then set SCK low again  
          
          //SPI_SendData(uint8_t Data)
          //byte=SPI_ReceiveData(void)
   	}
      //  printf("\n\r %d \n\r",byte);
        return(byte);   */        		  // return read byte*/
}
/**************************************************/

/**************************************************
Function: SPI_RW_Reg();

  Description:
  Writes value 'value' to register 'reg'
************************************************/
uchar SPI_RW_Reg(BYTE reg, BYTE value)
{
	uchar status;
	
	GPIO_WriteLow(NRF24L01_CS_PORT,NRF24L01_CS_PIN);                // CSN low, init SPI transaction
	status = SPI_RW(reg);      // select register
	SPI_RW(value);             // ..and write value to it..
	GPIO_WriteHigh(NRF24L01_CS_PORT,NRF24L01_CS_PIN);                   // CSN high again
	return(status);            // return nRF24L01 status byte
}
/**************************************************/

/**************************************************
Function: SPI_Read();

  Description:
  Read one byte from nRF24L01 register, 'reg'
**************************************************/
BYTE SPI_Read(BYTE reg)
{
	BYTE reg_val;
	
	GPIO_WriteLow(NRF24L01_CS_PORT,NRF24L01_CS_PIN);                 // CSN low, initialize SPI communication...
	//NRF24L01_CS_LOW() ;
	SPI_RW(reg);            // Select register to read from..
	reg_val = SPI_RW(0);    // ..then read registervalue
	GPIO_WriteHigh(NRF24L01_CS_PORT,NRF24L01_CS_PIN);           // CSN high, terminate SPI communication
	//NRF24L01_CS_HIGH() ;
	
	return(reg_val);        // return register value
}
/**************************************************/

/*************************************************
Function: SPI_Read_Buf();

  Description:
  
**************************************************/
uchar SPI_Read_Buf(BYTE reg, BYTE *pBuf, BYTE bytes)
{
	uchar status,byte_ctr;
	
	GPIO_WriteLow(NRF24L01_CS_PORT,NRF24L01_CS_PIN);// Set CSN low, init SPI tranaction
	status = SPI_RW(reg);       		// Select register to write to and read status byte
	//printf("\n\r %d \n\r",status);
	for(byte_ctr=0;byte_ctr<bytes;byte_ctr++)
		pBuf[byte_ctr] = SPI_RW(0);    // 
	
	GPIO_WriteHigh(NRF24L01_CS_PORT,NRF24L01_CS_PIN);

	return(status);                    // return nRF24L01 status byte
}
/**************************************************/

/**************************************************
Function: SPI_Write_Buf();

  Description:
  Writes contents of buffer '*pBuf' to nRF24L01
  Typically used to write TX payload, Rx/Tx address
*************************************************/
uchar SPI_Write_Buf(uchar reg, uchar *pBuf, uchar bytes)
{
	uchar status,byte_ctr;
	       
        GPIO_WriteLow(NRF24L01_CS_PORT,NRF24L01_CS_PIN);
	status = SPI_RW(reg);        
	for(byte_ctr=0; byte_ctr<bytes; byte_ctr++) //
		SPI_RW(*pBuf++);
        GPIO_WriteHigh(NRF24L01_CS_PORT,NRF24L01_CS_PIN);
	return(status);          // 
}
/**************************************************/

/**************************************************
Function: RX_Mode();

  Description:
  
*************************************************/
void RX_Mode(void)
{
	GPIO_WriteLow(NRF24L01_CE_PORT,NRF24L01_CE_PIN);
        
        
        SPI_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);    // Writes TX_Address to nRF24L01
        SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, RX_ADDRESS, RX_ADR_WIDTH); // Use the same address on the RX device as the TX device
	
	SPI_RW_Reg(WRITE_REG + EN_AA, 0x01);      //Ƶ0Զ	ACKӦ	 
	SPI_RW_Reg(WRITE_REG + EN_RXADDR, 0x01);  //յַֻƵ0 
	SPI_RW_Reg(WRITE_REG + RF_CH, 40);        //   ŵΪ2.4GHZշһ
        //SPI_RW_Reg(WRITE_REG + SETUP_RETR, 0x1a);
	SPI_RW_Reg(WRITE_REG + RX_PW_P0, RX_PLOAD_WIDTH); //ýݳȣΪ32ֽ
	SPI_RW_Reg(WRITE_REG + RF_SETUP, 0x07); // ÷Ϊ1MHZ书Ϊֵ0dB 
	
	
        SPI_RW_Reg(WRITE_REG + CONFIG, 0x0f);    //power up  1: PRX
        //CE = 1; 
	GPIO_WriteHigh(NRF24L01_CE_PORT,NRF24L01_CE_PIN);
	inerDelay_us(130);
        
}
/**************************************************/
/**************************************************
Function: Set_TX_Mode()

  Description:
  
*************************************************/
void TX_Mode(void)
{
	GPIO_WriteLow(NRF24L01_CE_PORT,NRF24L01_CE_PIN);
	SPI_RW_Reg(WRITE_REG + CONFIG, 0x02);   //0x0E		 // IRQշжӦ16λCRC
	
	SPI_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);    // дصַ	
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, RX_ADDRESS, RX_ADR_WIDTH); // дն˵ַ
	
	SPI_RW_Reg(WRITE_REG + EN_AA, 0x01);//0x01);      //  Ƶ0Զ	ACKӦ	
	SPI_RW_Reg(WRITE_REG + EN_RXADDR, 0x01);  //  յַֻƵ0ҪƵԲοPage21  
	SPI_RW_Reg(WRITE_REG + SETUP_RETR, 0x1a); // Զطʱʹ500us + 86us, 10 retrans...
	SPI_RW_Reg(WRITE_REG + RF_CH, 40);        //   ŵΪ2.4GHZշһ
//	SPI_RW_Reg(WRITE_REG + RX_PW_P0, RX_PLOAD_WIDTH); //ýݳȣΪ32ֽ
	SPI_RW_Reg(WRITE_REG + RF_SETUP, 0x07);   		//÷Ϊ1MHZ书Ϊֵ0dB

	SPI_RW_Reg(WRITE_REG + CONFIG, 0x0e);//0x0E);

        GPIO_WriteHigh(NRF24L01_CE_PORT,NRF24L01_CE_PIN);
}
/**************************************************/
unsigned char nRF24L01_RxPacket(unsigned char* rx_buf)
{
    unsigned char revale=0;

	RX_Mode();
	stat=SPI_Read(STATUS);	// read register STATUS's value
	SPI_RW_Reg(FLUSH_RX,0xff);//RX FIFOĴ
	if(stat&0x40)				// if receive data ready (RX_DR) interrupt
	{ 
	    SPI_Read_Buf(RD_RX_PLOAD,rx_buf,TX_PLOAD_WIDTH);// read receive payload from RX_FIFO buffer		
	    SPI_RW_Reg(FLUSH_RX,0xff);//RX FIFOĴ 
		revale =1;//we have receive data    
	}
	return revale;
}

/**************************************************
Function: nRF24L01_TxPacket();

  Description:
  This function initializes one nRF24L01 device to
  TX mode, set TX address, set RX address for auto.ack,
  fill TX payload, select RF channel, datarate & TX pwr.
  PWR_UP is set, CRC(2 bytes) is enabled, & PRIM:TX.
  
	ToDo: One high pulse(>10us) on CE will now send this
	packet and expext an acknowledgment from the RX device.
**************************************************/
unsigned char nRF24L01_TxPacket(unsigned char * tx_buf)
{

	//NRF24L01_CE_LOW();
	SPI_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);    // 
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH); 

        SPI_RW_Reg(WRITE_REG + EN_AA, 0x01);//0x01);      //  Ƶ0Զ	ACKӦ	
	SPI_RW_Reg(WRITE_REG + EN_RXADDR, 0x01);  //  յַֻƵ0ҪƵԲοPage21  
	//SPI_RW_Reg(WRITE_REG + SETUP_RETR, 0x1a); // Զطʱʹ500us + 86us, 10 retrans...
	SPI_RW_Reg(WRITE_REG + RF_CH, 40);        //   ŵΪ2.4GHZշһ

	SPI_RW_Reg(WRITE_REG + RF_SETUP, 0x07);  //÷Ϊ1MHZ书Ϊֵ0dB
        
        GPIO_WriteLow(NRF24L01_CE_PORT,NRF24L01_CE_PIN);
        
 	SPI_Write_Buf(WR_TX_PLOAD, tx_buf, TX_PLOAD_WIDTH);        
        SPI_RW_Reg(WRITE_REG + CONFIG, 0x0E);//0x0E);
        
	GPIO_WriteHigh(NRF24L01_CE_PORT,NRF24L01_CE_PIN);
        
	inerDelay_us(35);		//ʱ10us
        
        GPIO_WriteLow(NRF24L01_CE_PORT,NRF24L01_CE_PIN);
        
        //////////////////////////////////////////////NRF24L01_IRQ!=0
        
	while(GPIO_ReadInputPin(NRF24L01_IRQ_PORT, NRF24L01_IRQ_PIN)!=0);//ȴ
	stat=SPI_Read(STATUS);//ȡ״̬Ĵֵ	   
	SPI_RW_Reg(WRITE_REG+STATUS,stat); //TX_DSMAX_RTжϱ־
	if(stat&MAX_TX)//ﵽط
		{
		SPI_RW_Reg(FLUSH_TX,0xff);//TX FIFOĴ 
		return MAX_TX; 
		}
	if(stat&TX_OK)//
		{
		return TX_OK;
		}
	return 0xff;//ԭʧ
}
	

/**************************************************/

//ϵNRF24L01Ƿλ
//д5ȻٶбȽϣͬʱֵ:0ʾλ;򷵻1ʾλ	
BYTE NRF24L01_Check(void)
{
	BYTE buf[5]={0xa5,0xa5,0xa5,0xa5,0xa5};
	BYTE buf1[5]={0xff,0xff,0xff,0xff,0xff};;
	BYTE i;   	 
	SPI_Write_Buf(WRITE_REG+TX_ADDR,buf,5);//д5ֽڵĵַ.	
	SPI_Read_Buf(TX_ADDR,buf1,5);              //дĵַ  	
	for(i=0;i<5;i++)
		if(buf1[i]!=0xa5)
			break;					   
	if(i!=5)
		return 1;                               //NRF24L01λ	
	return 0;		                                //NRF24L01λ
}	 	
/*************************************************************/
